***********************************************************************
** A program by Romain Strieff to show using the WINAPI to create
** a progress bar. This particular progress bar can be hooked into
** operations, such as copying a file, possibly indexing tables, 
** and more ...
***********************************************************************
set procedure to progres2.cc additive

f=new progress(100)
f.form.text="Demo of progressbar"
f.form.description.text="Test of progressbar"
for n=1 to 100
sleep 0.1
f.update()
next
f.release()


*---------Code for creating PROGRESS.DBF
    if .not. file ( "PROGRESS.DBF" )
       create table "PROGRESS.DBF" ( ;
                     PROGRESS.'DUMMY'       CHAR(1))
       use progress exclusive
       generate 20000
       use
    endif
*---------End PROGRESS.DBF

use progress
f=new progress(reccount())
f.form.text="Copying "+ltrim(str(reccount())) +" records"
f.form.description.text="processing: "+dbf()
copy to temp while f.update()

use
erase temp.dbf
erase progress.dbf
f.release()


CLASS PROGRESS(nMaxvalues)
      if pcount()=0
         this.maxvalues=0
      else
         this.maxvalues=nMaxvalues
      endif
      this.CountedValue=0
      this.form=new PROGBARFORM()
      if file("CENTER.PRG")
         set procedure to center.prg additive
         this.form.left=-300
         this.form.onopen={;centerform(this)}
      endif
      this.form.mdi=.f.
      this.form.minimize=.f.
      this.form.maximize=.f.
      this.form.enabled=.f.
      this.form.topmost=.t.
      this.form.progbar1.value=0
      this.form.progbar1.maxvalue=20
      this.form.canclose={;return .f.}
      this.form.onlostfocus={;this.setfocus()}
      if this.maxvalues>0
         this.form.open()
      endif
      
    Procedure Reset
    this.form.progbar1.value=0
    this.CountedValue=0
    this.maxvalues=0
    
    Procedure Update(nValue)
    if pcount()>0
      this.CountedValue=this.CountedValue+n
    else
      this.CountedValue=this.CountedValue+1
    endif
    if int((  this.form.progbar1.maxvalue/this.maxvalues )* this.countedValue);
       >this.form.progbar1.value
    this.form.progbar1.value=this.form.progbar1.value+1
    this.form.progbar1.redraw()
    endif
    Return .t.
    
    Procedure Release
    this.form.onlostfocus=null
    this.form.canclose=null
    this.form.release()

ENDCLASS

CLASS PROGBARFORM OF FORM

   this.Width = 60
   this.Text = ""
   this.Height = 7
   this.Left = 35
   this.Top = 0

   DEFINE PROGBAR2 PROGBAR1 OF THIS;
       PROPERTY; 
         Width 46.5,;
         Height 1.75,;
         Left 6.5,;
         Top 2.25

   DEFINE TEXT DESCRIPTION OF THIS;
       PROPERTY; 
         Width 46.5,;
         Height 1.5,;
         Left 6.5,;
         Top 4.5,;
         Alignment 4

ENDCLASS

